Create a bill and its payment together
curl --request POST \
--url https://api.sync2books.com/bills/with-payment/{connectionId} \
--header 'Content-Type: application/json' \
--header 'X-API-Key: <api-key>' \
--data '
{
"supplierRef": {
"id": "<string>",
"name": "<string>"
},
"issueDate": "2023-12-25",
"currency": "<string>",
"subTotal": 123,
"taxAmount": 123,
"totalAmount": 123,
"lineItems": [
{
"unitAmount": 123,
"quantity": 2,
"isDirectCost": true,
"lineNumber": 123,
"description": "<string>",
"unitOfMeasurement": "<string>",
"discountAmount": 123,
"discountPercentage": 50,
"subTotal": 123,
"taxAmount": 123,
"totalAmount": 123,
"trackingCategoryRefs": [
{
"id": "<string>",
"name": "<string>"
}
]
}
],
"billCode": "<string>",
"reference": "<string>",
"purchaseOrderRefs": [
{
"id": "<string>",
"purchaseOrderNumber": "<string>"
}
],
"dueDate": "2023-12-25",
"currencyRate": 1.0001,
"amountDue": 123,
"note": "<string>",
"withholdingTax": [
{
"name": "<string>",
"amount": 123
}
]
}
'import requests
url = "https://api.sync2books.com/bills/with-payment/{connectionId}"
payload = {
"supplierRef": {
"id": "<string>",
"name": "<string>"
},
"issueDate": "2023-12-25",
"currency": "<string>",
"subTotal": 123,
"taxAmount": 123,
"totalAmount": 123,
"lineItems": [
{
"unitAmount": 123,
"quantity": 2,
"isDirectCost": True,
"lineNumber": 123,
"description": "<string>",
"unitOfMeasurement": "<string>",
"discountAmount": 123,
"discountPercentage": 50,
"subTotal": 123,
"taxAmount": 123,
"totalAmount": 123,
"trackingCategoryRefs": [
{
"id": "<string>",
"name": "<string>"
}
]
}
],
"billCode": "<string>",
"reference": "<string>",
"purchaseOrderRefs": [
{
"id": "<string>",
"purchaseOrderNumber": "<string>"
}
],
"dueDate": "2023-12-25",
"currencyRate": 1.0001,
"amountDue": 123,
"note": "<string>",
"withholdingTax": [
{
"name": "<string>",
"amount": 123
}
]
}
headers = {
"X-API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
supplierRef: {id: '<string>', name: '<string>'},
issueDate: '2023-12-25',
currency: '<string>',
subTotal: 123,
taxAmount: 123,
totalAmount: 123,
lineItems: [
{
unitAmount: 123,
quantity: 2,
isDirectCost: true,
lineNumber: 123,
description: '<string>',
unitOfMeasurement: '<string>',
discountAmount: 123,
discountPercentage: 50,
subTotal: 123,
taxAmount: 123,
totalAmount: 123,
trackingCategoryRefs: [{id: '<string>', name: '<string>'}]
}
],
billCode: '<string>',
reference: '<string>',
purchaseOrderRefs: [{id: '<string>', purchaseOrderNumber: '<string>'}],
dueDate: '2023-12-25',
currencyRate: 1.0001,
amountDue: 123,
note: '<string>',
withholdingTax: [{name: '<string>', amount: 123}]
})
};
fetch('https://api.sync2books.com/bills/with-payment/{connectionId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.sync2books.com/bills/with-payment/{connectionId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'supplierRef' => [
'id' => '<string>',
'name' => '<string>'
],
'issueDate' => '2023-12-25',
'currency' => '<string>',
'subTotal' => 123,
'taxAmount' => 123,
'totalAmount' => 123,
'lineItems' => [
[
'unitAmount' => 123,
'quantity' => 2,
'isDirectCost' => true,
'lineNumber' => 123,
'description' => '<string>',
'unitOfMeasurement' => '<string>',
'discountAmount' => 123,
'discountPercentage' => 50,
'subTotal' => 123,
'taxAmount' => 123,
'totalAmount' => 123,
'trackingCategoryRefs' => [
[
'id' => '<string>',
'name' => '<string>'
]
]
]
],
'billCode' => '<string>',
'reference' => '<string>',
'purchaseOrderRefs' => [
[
'id' => '<string>',
'purchaseOrderNumber' => '<string>'
]
],
'dueDate' => '2023-12-25',
'currencyRate' => 1.0001,
'amountDue' => 123,
'note' => '<string>',
'withholdingTax' => [
[
'name' => '<string>',
'amount' => 123
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"X-API-Key: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.sync2books.com/bills/with-payment/{connectionId}"
payload := strings.NewReader("{\n \"supplierRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"issueDate\": \"2023-12-25\",\n \"currency\": \"<string>\",\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"lineItems\": [\n {\n \"unitAmount\": 123,\n \"quantity\": 2,\n \"isDirectCost\": true,\n \"lineNumber\": 123,\n \"description\": \"<string>\",\n \"unitOfMeasurement\": \"<string>\",\n \"discountAmount\": 123,\n \"discountPercentage\": 50,\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"trackingCategoryRefs\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n }\n ]\n }\n ],\n \"billCode\": \"<string>\",\n \"reference\": \"<string>\",\n \"purchaseOrderRefs\": [\n {\n \"id\": \"<string>\",\n \"purchaseOrderNumber\": \"<string>\"\n }\n ],\n \"dueDate\": \"2023-12-25\",\n \"currencyRate\": 1.0001,\n \"amountDue\": 123,\n \"note\": \"<string>\",\n \"withholdingTax\": [\n {\n \"name\": \"<string>\",\n \"amount\": 123\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.sync2books.com/bills/with-payment/{connectionId}")
.header("X-API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"supplierRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"issueDate\": \"2023-12-25\",\n \"currency\": \"<string>\",\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"lineItems\": [\n {\n \"unitAmount\": 123,\n \"quantity\": 2,\n \"isDirectCost\": true,\n \"lineNumber\": 123,\n \"description\": \"<string>\",\n \"unitOfMeasurement\": \"<string>\",\n \"discountAmount\": 123,\n \"discountPercentage\": 50,\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"trackingCategoryRefs\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n }\n ]\n }\n ],\n \"billCode\": \"<string>\",\n \"reference\": \"<string>\",\n \"purchaseOrderRefs\": [\n {\n \"id\": \"<string>\",\n \"purchaseOrderNumber\": \"<string>\"\n }\n ],\n \"dueDate\": \"2023-12-25\",\n \"currencyRate\": 1.0001,\n \"amountDue\": 123,\n \"note\": \"<string>\",\n \"withholdingTax\": [\n {\n \"name\": \"<string>\",\n \"amount\": 123\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.sync2books.com/bills/with-payment/{connectionId}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"supplierRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"issueDate\": \"2023-12-25\",\n \"currency\": \"<string>\",\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"lineItems\": [\n {\n \"unitAmount\": 123,\n \"quantity\": 2,\n \"isDirectCost\": true,\n \"lineNumber\": 123,\n \"description\": \"<string>\",\n \"unitOfMeasurement\": \"<string>\",\n \"discountAmount\": 123,\n \"discountPercentage\": 50,\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"trackingCategoryRefs\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n }\n ]\n }\n ],\n \"billCode\": \"<string>\",\n \"reference\": \"<string>\",\n \"purchaseOrderRefs\": [\n {\n \"id\": \"<string>\",\n \"purchaseOrderNumber\": \"<string>\"\n }\n ],\n \"dueDate\": \"2023-12-25\",\n \"currencyRate\": 1.0001,\n \"amountDue\": 123,\n \"note\": \"<string>\",\n \"withholdingTax\": [\n {\n \"name\": \"<string>\",\n \"amount\": 123\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"bill": {},
"billPayment": {},
"message": "<string>",
"billSynced": true,
"paymentSynced": true,
"warning": "<string>"
}Bills
Create a bill and its payment together
POST
/
bills
/
with-payment
/
{connectionId}
Create a bill and its payment together
curl --request POST \
--url https://api.sync2books.com/bills/with-payment/{connectionId} \
--header 'Content-Type: application/json' \
--header 'X-API-Key: <api-key>' \
--data '
{
"supplierRef": {
"id": "<string>",
"name": "<string>"
},
"issueDate": "2023-12-25",
"currency": "<string>",
"subTotal": 123,
"taxAmount": 123,
"totalAmount": 123,
"lineItems": [
{
"unitAmount": 123,
"quantity": 2,
"isDirectCost": true,
"lineNumber": 123,
"description": "<string>",
"unitOfMeasurement": "<string>",
"discountAmount": 123,
"discountPercentage": 50,
"subTotal": 123,
"taxAmount": 123,
"totalAmount": 123,
"trackingCategoryRefs": [
{
"id": "<string>",
"name": "<string>"
}
]
}
],
"billCode": "<string>",
"reference": "<string>",
"purchaseOrderRefs": [
{
"id": "<string>",
"purchaseOrderNumber": "<string>"
}
],
"dueDate": "2023-12-25",
"currencyRate": 1.0001,
"amountDue": 123,
"note": "<string>",
"withholdingTax": [
{
"name": "<string>",
"amount": 123
}
]
}
'import requests
url = "https://api.sync2books.com/bills/with-payment/{connectionId}"
payload = {
"supplierRef": {
"id": "<string>",
"name": "<string>"
},
"issueDate": "2023-12-25",
"currency": "<string>",
"subTotal": 123,
"taxAmount": 123,
"totalAmount": 123,
"lineItems": [
{
"unitAmount": 123,
"quantity": 2,
"isDirectCost": True,
"lineNumber": 123,
"description": "<string>",
"unitOfMeasurement": "<string>",
"discountAmount": 123,
"discountPercentage": 50,
"subTotal": 123,
"taxAmount": 123,
"totalAmount": 123,
"trackingCategoryRefs": [
{
"id": "<string>",
"name": "<string>"
}
]
}
],
"billCode": "<string>",
"reference": "<string>",
"purchaseOrderRefs": [
{
"id": "<string>",
"purchaseOrderNumber": "<string>"
}
],
"dueDate": "2023-12-25",
"currencyRate": 1.0001,
"amountDue": 123,
"note": "<string>",
"withholdingTax": [
{
"name": "<string>",
"amount": 123
}
]
}
headers = {
"X-API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
supplierRef: {id: '<string>', name: '<string>'},
issueDate: '2023-12-25',
currency: '<string>',
subTotal: 123,
taxAmount: 123,
totalAmount: 123,
lineItems: [
{
unitAmount: 123,
quantity: 2,
isDirectCost: true,
lineNumber: 123,
description: '<string>',
unitOfMeasurement: '<string>',
discountAmount: 123,
discountPercentage: 50,
subTotal: 123,
taxAmount: 123,
totalAmount: 123,
trackingCategoryRefs: [{id: '<string>', name: '<string>'}]
}
],
billCode: '<string>',
reference: '<string>',
purchaseOrderRefs: [{id: '<string>', purchaseOrderNumber: '<string>'}],
dueDate: '2023-12-25',
currencyRate: 1.0001,
amountDue: 123,
note: '<string>',
withholdingTax: [{name: '<string>', amount: 123}]
})
};
fetch('https://api.sync2books.com/bills/with-payment/{connectionId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.sync2books.com/bills/with-payment/{connectionId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'supplierRef' => [
'id' => '<string>',
'name' => '<string>'
],
'issueDate' => '2023-12-25',
'currency' => '<string>',
'subTotal' => 123,
'taxAmount' => 123,
'totalAmount' => 123,
'lineItems' => [
[
'unitAmount' => 123,
'quantity' => 2,
'isDirectCost' => true,
'lineNumber' => 123,
'description' => '<string>',
'unitOfMeasurement' => '<string>',
'discountAmount' => 123,
'discountPercentage' => 50,
'subTotal' => 123,
'taxAmount' => 123,
'totalAmount' => 123,
'trackingCategoryRefs' => [
[
'id' => '<string>',
'name' => '<string>'
]
]
]
],
'billCode' => '<string>',
'reference' => '<string>',
'purchaseOrderRefs' => [
[
'id' => '<string>',
'purchaseOrderNumber' => '<string>'
]
],
'dueDate' => '2023-12-25',
'currencyRate' => 1.0001,
'amountDue' => 123,
'note' => '<string>',
'withholdingTax' => [
[
'name' => '<string>',
'amount' => 123
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"X-API-Key: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.sync2books.com/bills/with-payment/{connectionId}"
payload := strings.NewReader("{\n \"supplierRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"issueDate\": \"2023-12-25\",\n \"currency\": \"<string>\",\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"lineItems\": [\n {\n \"unitAmount\": 123,\n \"quantity\": 2,\n \"isDirectCost\": true,\n \"lineNumber\": 123,\n \"description\": \"<string>\",\n \"unitOfMeasurement\": \"<string>\",\n \"discountAmount\": 123,\n \"discountPercentage\": 50,\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"trackingCategoryRefs\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n }\n ]\n }\n ],\n \"billCode\": \"<string>\",\n \"reference\": \"<string>\",\n \"purchaseOrderRefs\": [\n {\n \"id\": \"<string>\",\n \"purchaseOrderNumber\": \"<string>\"\n }\n ],\n \"dueDate\": \"2023-12-25\",\n \"currencyRate\": 1.0001,\n \"amountDue\": 123,\n \"note\": \"<string>\",\n \"withholdingTax\": [\n {\n \"name\": \"<string>\",\n \"amount\": 123\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.sync2books.com/bills/with-payment/{connectionId}")
.header("X-API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"supplierRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"issueDate\": \"2023-12-25\",\n \"currency\": \"<string>\",\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"lineItems\": [\n {\n \"unitAmount\": 123,\n \"quantity\": 2,\n \"isDirectCost\": true,\n \"lineNumber\": 123,\n \"description\": \"<string>\",\n \"unitOfMeasurement\": \"<string>\",\n \"discountAmount\": 123,\n \"discountPercentage\": 50,\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"trackingCategoryRefs\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n }\n ]\n }\n ],\n \"billCode\": \"<string>\",\n \"reference\": \"<string>\",\n \"purchaseOrderRefs\": [\n {\n \"id\": \"<string>\",\n \"purchaseOrderNumber\": \"<string>\"\n }\n ],\n \"dueDate\": \"2023-12-25\",\n \"currencyRate\": 1.0001,\n \"amountDue\": 123,\n \"note\": \"<string>\",\n \"withholdingTax\": [\n {\n \"name\": \"<string>\",\n \"amount\": 123\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.sync2books.com/bills/with-payment/{connectionId}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"supplierRef\": {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n },\n \"issueDate\": \"2023-12-25\",\n \"currency\": \"<string>\",\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"lineItems\": [\n {\n \"unitAmount\": 123,\n \"quantity\": 2,\n \"isDirectCost\": true,\n \"lineNumber\": 123,\n \"description\": \"<string>\",\n \"unitOfMeasurement\": \"<string>\",\n \"discountAmount\": 123,\n \"discountPercentage\": 50,\n \"subTotal\": 123,\n \"taxAmount\": 123,\n \"totalAmount\": 123,\n \"trackingCategoryRefs\": [\n {\n \"id\": \"<string>\",\n \"name\": \"<string>\"\n }\n ]\n }\n ],\n \"billCode\": \"<string>\",\n \"reference\": \"<string>\",\n \"purchaseOrderRefs\": [\n {\n \"id\": \"<string>\",\n \"purchaseOrderNumber\": \"<string>\"\n }\n ],\n \"dueDate\": \"2023-12-25\",\n \"currencyRate\": 1.0001,\n \"amountDue\": 123,\n \"note\": \"<string>\",\n \"withholdingTax\": [\n {\n \"name\": \"<string>\",\n \"amount\": 123\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"bill": {},
"billPayment": {},
"message": "<string>",
"billSynced": true,
"paymentSynced": true,
"warning": "<string>"
}Authorizations
Your application's API key (sk_development_… or sk_production_…). An optional X-Signature / X-Timestamp HMAC pair may additionally be sent for stronger security — see Authentication.
Path Parameters
The connection to the accounting system to write through.
Body
application/json
Show child attributes
Show child attributes
Decimal amount in the document's currency.
Decimal amount in the document's currency.
Decimal amount in the document's currency.
Show child attributes
Show child attributes
Available options:
Unknown, Open, PartiallyPaid, Paid, Void, Draft Show child attributes
Show child attributes
Required range:
x >= 0.0001Decimal amount in the document's currency.
Show child attributes
Show child attributes